% Voltage

Voltages = zeros(Res,8);


for j=1:Res
    for k=1:8
        % Torque from PM linkage at freq. 20 Hz.
        Voltages(j,k) = N*(PMContribution(1+mod(j-1-(Res/8)*(k-1),Res))-PMContribution(1+mod(j-2-(Res/8)*(k-1),Res)))*7200;
    end
end


% Constructing a phase-voltage:

Phase1 = zeros(Res,1);
Phase2 = zeros(Res,1);

for i=1:Res
    Phase1(i)= Voltages(i,1)+Voltages(i,2)+0*Voltages(i,3)+0*Voltages(i,4);
end


for i=1:Res
    Phase2(i)= Voltages(i,1)+0*Voltages(i,2)+0*Voltages(i,3)+1*Voltages(i,5);
end



RMS1=0;
RMS2=0;
RMSSingle=0;


for i=1:Res
    RMS1 = RMS1 +sqrt((Phase1(i)^2))/Res;
end

for i=1:Res
    RMS2 = RMS2 +sqrt((Phase2(i)^2))/Res;
end

for i=1:Res
    RMSSingle = RMSSingle +sqrt((Voltages(i,1)^2))/Res;
end