%**************************************************************************

% Static simulation: t=0
t = 0; 

%**************************************************************************
% Entering the model after the equivalent scheme (see PDF-file) 
% The first element is for time steps, which are not supported elsewhere in
% the script yet.

Noder = {1e-6,0.002;...
        ' 0- 2 I 0 0 ',-Phir;...   % Permanent magnets provide flux
        ' 2- 3 I 0 0 ',Phir;...
        ' 3- 4 I 0 0 ',-Phir;...
        ' 4- 5 I 0 0 ',Phir;...
        ' 5- 6 I 0 0 ',-Phir;...
        ' 6- 7 I 0 0 ',Phir;...
        ' 7- 8 I 0 0 ',-Phir;...
        ' 8- 9 I 0 0 ',Phir;...
        ' 9-10 I 0 0 ',-Phir;...
        '10-11 I 0 0 ',Phir;...
        '11-12 I 0 0 ',-Phir;...
        '12-13 I 0 0 ',Phir;...
        '13-14 I 0 0 ',-Phir;...
        '14-15 I 0 0 ',Phir;...
        '15-16 I 0 0 ',-Phir;...
        '16- 0 I 0 0 ',Phir;...
        ' 0- 1 R ',Rg(1);...
        ' 2- 1 R ',Rg(2);...
        ' 3- 1 R ',Rg(3);...
        ' 4- 1 R ',Rg(4);...
        ' 5- 1 R ',Rg(5);...
        ' 6- 1 R ',Rg(6);...
        ' 7- 1 R ',Rg(7);...
        ' 8- 1 R ',Rg(8);...
        ' 9- 1 R ',Rg(9);...
        '10- 1 R ',Rg(10);...
        '11- 1 R ',Rg(11);...
        '12- 1 R ',Rg(12);...
        '13- 1 R ',Rg(13);...
        '14- 1 R ',Rg(14);...
        '15- 1 R ',Rg(15);...
        '16- 1 R ',Rg(16);...
        ' 0- 2 R ',Rs;...
        ' 2- 3 R ',Rs;...
        ' 3- 4 R ',Rs;...
        ' 4- 5 R ',Rs;...
        ' 5- 6 R ',Rs;...
        ' 6- 7 R ',Rs;...
        ' 7- 8 R ',Rs;...
        ' 8- 9 R ',Rs;...
        ' 9-10 R ',Rs;...
        '10-11 R ',Rs;...
        '11-12 R ',Rs;...
        '12-13 R ',Rs;...
        '13-14 R ',Rs;...
        '14-15 R ',Rs;...
        '15-16 R ',Rs;...
        '16- 0 R ',Rs;...
        };
    
%**************************************************************************
% Leser inn modellen motstand for motstand. Den takler strmkilder og
% motstander. Nettverk funksjonen takler i tillegg Spg, Z, L,  brytere, C.
% Den gir ut Y matrisa og ant strm kilder samt node nummer. Snakke med
% Hidalen dersom du ikke forstr dette. Hper  f lagt til C etterhvert
% men m da verifisere modellen frst.

fid = fopen('exp.txt','w');
for i = 1:length(Noder)
    text1 = Noder{i,1};
    text2 = Noder{i,2};
    if i==1
        fprintf(fid,'%3.8f %f\n',text1,text2);
    else
        fprintf(fid,'%s %f\n',text1,text2);
    end
end
fclose(fid);

%**************************************************************************
%Calls the nettverk function, whiche the reads the file created above.

[Y, numN, numL,recL, numC, recC, numX, recX, numB, recB, numZ, recZ,numU,recU,numI,recI,dt,tmax]...
    =nettverk('exp.txt');

%**************************************************************************
% Forklaring:
% Creates vector with flux sources. The function is able to handle time
% varying sources, but the model is not

Phi=zeros(numN+numU+numB,1);
   for m=1:numI
    %Constant sources declared with Freq and Phase equal to zero -> cos(0)=1.   
    s=recI(m).Ampl;
    Phi=xAddTo(Phi,recI(m).Fra,-s);
    Phi=xAddTo(Phi,recI(m).Til, s);
end
for m=1:numU  
    Phi(numN+m)= recU(m).Ampl;
end    

NI = Y\Phi;


