%
% Uses the different values from node-scripts to assemble the torque
% expression:
%
%**************************************************************************
%Creating storage arrays for torque data
Selfsingle = zeros(Res,8);
Mutualsingle = zeros(Res,8);
PMsingle = zeros(Res,8);
Cogsingle = zeros(Res,8); 

Tkomp = zeros(Res,8);
Ckomp = zeros(Res,8);

MutualInductances = zeros(Res,7,8);

for i=1:Res
    for j=1:7
         for k=1:8    
             MutualInductances(i,j,k)= MutualInductance(1+mod(i-1-(Res/8)*(k-1),360),j);
         end
    end
end

for j=1:Res
    for k=1:8

        % Torque component from self inductance
            Self =0.5*(HistoricCoil(j,k)^2)*(SelfInductance(1+mod(j-1-(Res/8)*(k-1),360))...
                  -SelfInductance(1+mod(j-2-(Res/8)*(k-1),360)))./(2*pi./Res);
       
        % Torque from mutual inductances
        Mutual = 0;

        for i=1:7
            % The if-statement is to avoid NAN-values.
            if (HistoricCoil(j,k)*HistoricCoil(j,1+mod((k+i-1),8))~=0) &&...
                    (MutualInductances((1+mod(j-2,360)),i,k) <2) && ...
                    (MutualInductances((1+mod(j-2,360)),i,k) > -2)
                Mutual = Mutual+(0.5*(MutualInductances(j,i,k)-MutualInductances(1+mod(j-2,360),i,k))...
                         *HistoricCoil(j,k)*HistoricCoil(j,1+mod((k+i-1),8)))/(2*pi./Res);
            end
        end

        % Torque from PM linkage
        PM = N*HistoricCoil(j,k)*((PMScf(1+mod(j-1-(Res/8)*(k-1),Res))-PMScf(1+mod(j-2-(Res/8)...
             *(k-1),Res))))/(2*pi/Res);

        % Torque from permanent magnet (Cogging torque)
        PmCog= -0.5*(PMContribution(1+mod(j-1-(Res/8)*(k-1),360))^2)*(Zpast(1+mod(j-(Res/8)...
               *(k-1)-1,Res))-Zpast(1+mod((j-1)-(Res/8)*(k-1)-1,Res)))./(2*pi./Res); 

        % Storing the values
        Selfsingle(j,k) = Self;
        Mutualsingle(j,k) = Mutual;
        PMsingle(j,k) = PM;
        Cogsingle(j,k) = PmCog;
        
        Tkomp(j,k)=Self+Mutual+PM+PmCog;
        Ckomp(j,k)=PmCog;
    end
end

%Summing up the torque components    
torque = sum(Tkomp,2);   
ctorque = sum(Ckomp,2);


