function [G,numN,numL,recL,numC,recC,numX,recX,numB,recB,...
        numZ,recZ,numU,recU,numI,recI,dt,t]=nettverk(filnavn)

%pner fil for lesing
fid=fopen(filnavn);

%Leser frste linje som skal inneholde tidskritt og total beregningstid
line=fgetl(fid);
[tid]=sscanf(line,'%f %f');
dt=tid(1);t=tid(2);


AntallElement=0;
numB=0;
numL=0;
numC=0;
numX=0;
numZ=0;
numU=0;
numI=0;

Element=[];
NodeList=[];
recC=[];
recL=[];
%recX=[];
%recI=[];
%recU=[];
%recB=[];

n=1;
while ~(feof(fid))
    %Leser inn linje til tekststring fra tekstfil
    line=fgetl(fid);
    if ~isempty(line)
        %Leser fra tekststring
        inn=sscanf(line,'%i%1s%i %1c %f %f');
        Node1=inn(1);
        Node2=inn(3);
        NodeList=[NodeList Node1 Node2];        
        
        if (char(inn(4))=='R')|(char(inn(4))=='L')|(char(inn(4))=='C')
            AntallElement=AntallElement+1;
            Element(AntallElement,:)=[inn(1) inn(3) inn(4) inn(5)];
        elseif (char(inn(4))=='X')
            %Avleder.
            numX=numX+1;
            recX(numX)=LesUlin(line,fid);
        elseif (char(inn(4))=='B')
            numB=numB+1;
            recB(numB)=LesBryter(line);
        elseif (char(inn(4))=='Z')
            numZ=numZ+1;
            recZ(numZ)=LesLinje(line);
        elseif (char(inn(4))=='V')
            numU=numU+1;
            recU(numU)=LesSpenningskilde(line);
        elseif (char(inn(4))=='I')
            numI=numI+1;
            recI(numI)=LesStromkilde(line);
        end
    end
end

%Sorterer og fjerner felles noder
[Noder,a1,b1]=unique(NodeList);
%Fjerner jordnode
if Noder(1)==0
    numN=max(size(Noder))-1;
    Noder=Noder(2:numN+1);
else
    numN=max(size(Noder));
end

%Admitansmatrise
G=zeros(numN,numN);



for n=1:AntallElement
    %Undersker om element har forbindelse til jord    
    
    Node1=Element(n,1);
    Node2=Element(n,2);
    switch char(Element(n,3))        
    case 'R'        
        %Resistans
        Y=1/Element(n,4);
        G=SettInn(G,Node1,Node2,Y);        
        
    case 'L'
        %induktans
        numL=numL+1;
        recL(numL).Fra=Node1;
        recL(numL).Til=Node2;
        recL(numL).L=Element(n,4);
        recL(numL).I=0;
        recL(numL).pI=0;
        Y=dt/(2*Element(n,4));
        G=SettInn(G,Node1,Node2,Y);
        
    case 'C'
        %kapasitans
        numC=numC+1;
        recC(numC).Fra=Node1;
        recC(numC).Til=Node2;
        recC(numC).C=Element(n,4);
        recC(numC).I=0;
        recC(numC).pI=0;
        
        Y=(2*Element(n,4))/dt;
        G=SettInn(G,Node1,Node2,Y);        
    end %case
end

for n=1:numX      
    Node1=recX(n).Fra;
    Node2=recX(n).Til; 
    if recX(n).Type==1
      G=SettInn(G,Node1,Node2,recX(n).y0/recX(n).x0);        
    end  
end

for n=1:numZ      
    Antall=round(recZ(n).tau/dt);
    recZ(n).Siste=Antall;
    recZ(n).I_Fra=zeros(1,Antall);        
    recZ(n).v_Fra=zeros(1,Antall);
    recZ(n).I_Til=zeros(1,Antall);
    recZ(n).v_Til=zeros(1,Antall);
    recZ(n).If=0;
    recZ(n).It=0;

    Node1=recZ(n).Fra;
    Node2=recZ(n).Til;    
    if ~(Node1==0)
        Y=1/recZ(n).Impedans;        
        G=SettInn(G,Node1,0,Y);
    end
    
    if ~(Node2==0)
        Y=1/recZ(n).Impedans;
        G=SettInn(G,Node2,0,Y);
    end
end

fclose(fid);

if numB==0
    %recB=struct('Fra',[],'Til',[],'Type',[], 'Tilstand',[],'prevI',[], 'Data',[]);
    recB=[];
end
if numZ==0
    recZ=[];
end
if numX==0
    recX=[];
end
if numI==0
    recI=[];
end
if numU==0
    recU=[];
end

%Utvider G matrise
G_ext=zeros(numN+numU+numB,numN+numU+numB);
G_ext(1:numN,1:numN)=G;
G=G_ext;
for i=1:numU
    if recU(i).Fra~=0
        G(recU(i).Fra,numN+i)=1;
       G(numN+i,recU(i).Fra)=1;
    end
        if recU(i).Til~=0
        G(recU(i).Til,numN+i)=-1;
       G(numN+i,recU(i).Til)=-1;
    end
end
for i=1:numB
    if recB(i).Fra~=0
       G(numN+numU+i,recB(i).Fra)=1;
    end
        if recB(i).Til~=0
%        G(recB(i).Til,numN+numU+i)=-1
       G(numN+numU+i,recB(i).Til)=-1;
       
    end
    G(numN+numU+i,numN+numU+i)=-1;
end






%****************************************************************************************************
%********** FUNKSJONER  *****************************************************************************
%****************************************************************************************************

function Bryter=LesBryter(line)

%[inn,LesteElement,Error,SisteLest]=sscanf(line,'%i%c%i %c',4);
[inn,LesteElement,Error,SisteLest]=sscanf(line,'%i%c%i %c %i',5);
Bryter=struct('Fra',[],'Til',[],'Type',[], 'Tilstand',0,'prevI',0, 'Data',[]);
Bryter.Fra=inn(1);
Bryter.Til=inn(3);
Bryter.Type=inn(5);

Data=sscanf(line(SisteLest:length(line)),'%f%*c',inf);
    
Bryter.Data=Data;

%****************************************************************************************************

function Linje=LesLinje(line)

inn=sscanf(line,'%i%1s%i %1c %f %f');
Linje.Fra=inn(1);
Linje.Til=inn(3);
Linje.Impedans=inn(5);
Linje.tau=inn(6);

%*****************************************************************************************************
function SpenningsKilde=LesSpenningskilde(line);
inn=sscanf(line,'%i%1s%i %1c %f %f %f');
SpenningsKilde.Fra=inn(1);
SpenningsKilde.Til=inn(3);
SpenningsKilde.Freq=inn(5);
SpenningsKilde.Phase=inn(6);
SpenningsKilde.Ampl=inn(7);


%*****************************************************************************************************
function StromKilde=LesStromkilde(line);
inn=sscanf(line,'%i%1s%i %1c %f %f %f');
StromKilde.Fra=inn(1);
StromKilde.Til=inn(3);
StromKilde.Freq=inn(5);
StromKilde.Phase=inn(6);
StromKilde.Ampl=inn(7);

%*****************************************************************************************************
function Ulin=LesUlin(line,fid);
inn=sscanf(line,'%i %1s %i %1c %i %i %f %f');
Ulin.Fra=inn(1);
Ulin.Til=inn(3);
Ulin.Type=inn(5);
Ulin.np=inn(6);
Ulin.x0=inn(7);
Ulin.y0=inn(8);
for i=1:inn(6)
    lineA=fgetl(fid);
    inn=sscanf(lineA,'%f %f');
    nx(i)=inn(1);
    ny(i)=inn(2);
end

Ulin.nx=nx;
Ulin.ny=ny;


%*****************************************************************************************************

function A=SettInn(A,Node1,Node2,a)

if (Node1==0)  
    A(Node2,Node2)=    A(Node2,Node2)+a;
elseif (Node2==0)
    A(Node1,Node1)=    A(Node1,Node1)+a;
else
    A(Node1,Node1)=    A(Node1,Node1)+a;
    A(Node2,Node2)=    A(Node2,Node2)+a;
    A(Node1,Node2)=    A(Node1,Node2)-a;
    A(Node2,Node1)=    A(Node2,Node1)-a;       
    
end

%*****************************************************************************************************
